routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

// Admin routes
Route::name('admin.')->prefix('admin')->namespace('Admin')->group(function () {
    Route::namespace('Auth')->middleware('guest:admin')->group(function () {
        // Login
        Route::get('/', 'LoginController@showLoginForm')->name('login');
        Route::post('/', 'LoginController@login');

        // Forget and reset Password
        Route::get('forgot-password', 'ForgotPasswordController@showLinkRequestForm')->name('forgot_password');
        Route::post('forgot-password', 'ForgotPasswordController@sendResetLinkEmail');
        Route::get('password/reset/{token}/{email?}', 'ResetPasswordController@showResetForm')->name('reset_password_link');
        Route::post('password/reset', 'ResetPasswordController@reset')->name('reset_password');
    });

    // Logged in admin user required
    Route::group(['middleware' => 'auth:admin'], function () {
        // Dashboard
        Route::get('/dashboard', 'AdminController@dashboard')->name('dashboard');

        Route::resource('students', 'StudentController');

        Route::resource('teachers', 'TeacherController');

        Route::resource('subjects', 'SubjectController');

        Route::resource('departments', 'DepartmentController');

        Route::resource('specialties', 'SpecialtyController');

        Route::resource('genders', 'GenderController');

        Route::resource('nationalities', 'NationalityController');

        // Profile
        Route::get('/profile', 'AdminController@profile')->name('profile');
        Route::post('/profile', 'AdminController@profileUpdate');
        Route::post('/password', 'AdminController@passwordUpdate')->name('password_update');

        // Logout
        Route::get('/logout', 'Auth\LoginController@logout')->name('logout');
    });
});

app/Gender.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Gender extends Model
{
    use SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name'
    ];

    /**
     * Validation rules
     *
     * @return array
     **/
    public static function validationRules()
    {
        return [
            'name' => 'required|string',
        ];
    }

    /**
     * Get the students for the Gender.
     */
    public function students()
    {
        return $this->hasMany('App\Student');
    }

    /**
     * Get the teachers for the Gender.
     */
    public function teachers()
    {
        return $this->hasMany('App\Teacher');
    }

    /**
     * Returns the paginated list of resources
     *
     * @return \Illuminate\Pagination\Paginator
     **/
    public static function getList()
    {
        return static::paginate(10);
    }
}

app/Http/Controllers/Admin/GenderController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Gender;
use App\Http\Controllers\Controller;

class GenderController extends Controller
{
    /**
     * Display a list of Genders.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $genders = Gender::getList();

        return view('admin.genders.index', compact('genders'));
    }

    /**
     * Show the form for creating a new Gender
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.genders.add');
    }

    /**
     * Save new Gender
     *
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store()
    {
        $validatedData = request()->validate(Gender::validationRules());

        $gender = Gender::create($validatedData);

        return redirect()->route('admin.genders.index')->with([
            'type' => 'success',
            'message' => 'Gender added'
        ]);
    }

    /**
     * Show the form for editing the specified Gender
     *
     * @param \App\Gender $gender
     * @return \Illuminate\Http\Response
     */
    public function edit(Gender $gender)
    {
        return view('admin.genders.edit', compact('gender'));
    }

    /**
     * Update the Gender
     *
     * @param \App\Gender $gender
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Gender $gender)
    {
        $validatedData = request()->validate(
            Gender::validationRules($gender->id)
        );

        $gender->update($validatedData);

        return redirect()->route('admin.genders.index')->with([
            'type' => 'success',
            'message' => 'Gender Updated'
        ]);
    }

    /**
     * Delete the Gender
     *
     * @param \App\Gender $gender
     * @return void
     */
    public function destroy(Gender $gender)
    {
        if ($gender->students()->count() || $gender->teachers()->count()) {
            return redirect()->route('admin.genders.index')->with([
                'type' => 'error',
                'message' => 'This record cannot be deleted as there are relationship dependencies.'
            ]);
        }

        $gender->delete();

        return redirect()->route('admin.genders.index')->with([
            'type' => 'success',
            'message' => 'Gender deleted successfully'
        ]);
    }
}

resources/views/admin/genders/add.blade.php
@extends('admin.layouts.app', ['page' => 'gender'])

@section('title', 'Add New Gender')

@section('content')

<div class="x_title">
    <h2>Add New Gender</h2>

    <div class="clearfix"></div>
</div>

<br>

<form role="form" method="POST" action="{{ route('admin.genders.store') }}">
    @csrf

    <div class="box-body">
        <div class="form-group">
            <label for="name">Name</label>
            <input type="text"
                class="form-control"
                name="name"
                required
                placeholder="Name"
                value="{{ old('name') }}"
                id="name"
            >
        </div>
    </div>

    <div class="box-footer">
        <button type="submit" class="btn btn-primary">Submit</button>

        <a href="{{ route('admin.genders.index') }}" class="btn btn-default">
            Cancel
        </a>
    </div>
</form>
@endsection

resources/views/admin/genders/edit.blade.php
@extends('admin.layouts.app', ['page' => 'gender'])

@section('title', 'Edit Gender')

@section('content')
<div class="x_title">
    <h2>Edit Gender</h2>

    <div class="clearfix"></div>
</div>

<form role="form" method="POST" action="{{ route('admin.genders.update', ['gender' => $gender->id]) }}">
    @csrf
    @method('PUT')

    <div class="box-body">
        <div class="form-group">
            <label for="name">Name</label>
            <input type="text"
                class="form-control"
                name="name"
                required
                placeholder="Name"
                value="{{ old('name', $gender->name) }}"
                id="name"
            >
        </div>
    </div>

    <div class="box-footer">
        <button type="submit" class="btn btn-primary">Update</button>

        <a href="{{ route('admin.genders.index') }}" class="btn btn-default">
            Cancel
        </a>
    </div>
</form>
@endsection

resources/views/admin/genders/index.blade.php
@extends('admin.layouts.app', ['page' => 'gender'])

@section('title', 'Genders')

@section('content')
<div class="x_title">
    <h2>Genders</h2>

    <a class="pull-right btn btn-primary"
        href="{{ route('admin.genders.create') }}"
    >
        Add New
    </a>

    <div class="clearfix"></div>
</div>

<br>

<div class="box-body">
    <table class="table table-bordered">
        <tr>
            <th>#</th>
            <th>Name</th>
            <th>Action</th>
        </tr>

        @forelse ($genders as $gender)
            <tr>
                <td>{{ $gender->id }}</td>
                <td>{{ $gender->name }}</td>
                <td>
                    <a href="{{ route('admin.genders.edit', ['gender' => $gender->id]) }}">
                        <i class="fa fa-pencil-square-o"></i>
                    </a>

                    <form action="{{ route('admin.genders.destroy', ['gender' => $gender->id]) }}"
                        method="POST"
                        class="inline pointer"
                    >
                        @csrf
                        @method('DELETE')

                        <a onclick="if (confirm('Are you sure?')) { this.parentNode.submit() }">
                            <i class="fa fa-trash-o"></i>
                        </a>
                    </form>
                </td>
            </tr>
        @empty
            <tr>
                <td colspan="3">No records found</td>
            </tr>
        @endforelse
    </table>
</div>

<div class="box-footer clearfix">
    {{ $genders->links('vendor.pagination.default') }}
</div>
@endsection